/*---------------------------------------------------------------------------
 * libcgi.c Ver3.96
 * CGIėp[eBeB
 *
 * Last update : 1998/10/05
 *
 * Copyright(C) 1997-98  Yuto Ikeno  All rights reserved.
 * e-mail : mew@onbiz.net
 * homepage:http://www.onbiz.net/~mew/
 * compile: gcc -c libcgi.c libpr.o
----------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "libcgi.h"
#include "libpr.h"

/*--- Code ---*/

char tochar(char *x){

	register char c;

	c  = (x[0] >= 'A' ? ((x[0] & 0xdf) - 'A') + 10 : (x[0] - '0'));
	c *= 16;
	c += (x[1] >= 'A' ? ((x[1] & 0xdf) - 'A') + 10 : (x[1] - '0'));
	return(c);
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid decode(char *)
@@@@Fchar *url		GR[hꂽ
@@@@FurlfR[hB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void decode(char *url){

	register int i, j;

	for(i = 0, j = 0; url[j]; ++i, ++j){
		if((url[i] = url[j]) == '%'){
			url[i] = tochar(&url[j + 1]);
			j += 2;
		}
		else if (url[i] == '+')
		url[i] = ' ';
	}
	url[i] = '\0';
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint getdata (char ***, char ***)
@@@@Fchar ***dname		tH[f[^namemۂ邽߂̗̈ւ̃|C^
@@@@@@@char ***dvalue	tH[f[^valuemۂ邽߂̗̈ւ̃|C^
߂l@@@Fint				name=valluȇg
@@@@FtH[̃f[^󂯎AnamevalueɕB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int getdata(char ***dname, char ***dvalue){

	char *qstring;			/*stdin data*/
	char *qs;
	char *method;			/*REQUEST_METHOD*/
	int ictl;				/*CONTENT_LENGTH*/
	int i;					/*JE^*/
	int count;				/*ddname=dvaluȇg*/
	char **tmpnam,**tmpval;	/*dnamedvaluei[Qz*/

	method = getenv("REQUEST_METHOD");	/*𒲂ׂ*/
	if(method == NULL){
		return -1;
	}else if(!strcmp(method, "POST")){	/*POST̎*/

		ictl = atoi(getenv("CONTENT_LENGTH"));
		if(ictl == 0)/*󂯎f[^݂Ȃ*/
			return -1;
		if((qstring = (char *)malloc(ictl + 1)) == NULL)
			return -1;
		if((fread(qstring, ictl, 1, stdin)) != 1)
			return -1;
		qstring[ictl] = '\0';

	}else if(!strcmp(method, "GET")){			/*GET̎*/
		qs = getenv("QUERY_STRING");
		if(qs == NULL){
			return -1;
		}else{
			ictl = strlen(qs);
			if((qstring = (char *)malloc(sizeof(char) * (ictl + 1))) == NULL)
				return -1;
			strcpy(qstring,qs);
			if(*qstring == '\0')
				return 0;
		}
	}

	for(i = 0, count = 0; *(qstring + i + 1); i++){
		if(*(qstring + i) == '&')
			count++;
	}

	count++;
	tmpval = (char**)malloc(sizeof(char*) * count);
	tmpnam = (char**)malloc(sizeof(char*) * count);

	/*----- fR[h -----*/
	for(i = 0; i < count; i++){
		tmpval[i] = (char*)malloc(strlen(qstring));
		tmpnam[i] = (char*)malloc(strlen(qstring));
		strspl(*(tmpval + i), qstring, '&');
		decode(*(tmpval + i));
		strspl(*(tmpnam + i), *(tmpval + i), '=');
	}
	*dname = tmpnam;
	*dvalue = tmpval;

	return count;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint freedata (char **, char **, int)
@@@@Fchar **name	Ώۂ̓񎟔z
@@@@@@@char **value	Ώۂ̓񎟔z
@@@@@@@int count		name=valuȇg
@@@@FnamevaluẽB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void freedata(char **name, char **value, int count){
	
	int i;

	for(i = 0; i < count; i++){
		if(*(name + i))
			free(*(name + i));
		if(*(value + i))
			free(*(value + i));
	}
	if(name)
		free(name);
	if(value)
		free(value);
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint getcookiesdata (char ***, char ***, char *)
@@@@Fchar ***cname		cookienamemۂ邽߂̗̈ւ̃|C^
@@@@@@@char ***cvalue	cookienamemۂ邽߂̗̈ւ̃|C^
@@@@@@@char *name		擾cookie̖O
߂l@@@Fint				name=valuȇg
@@@@FnameŎw肳ꂽcookienamevalue𕪊i[B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int getcookiesdata(char ***cname, char ***cvalue, char *name){

	char *http_cookie;			/*HTTP_COOKIE*/
	char unknown[10] = "Unknown";
	char *cookie_value;			/*Cookie*/
	char *cookie_name;		/*Cookie's Name*/
	int i,j;				/*JE^*/
	int count = -1;				/*name=valuȇg*/
	char **tmpnam,**tmpval;	/*namevaluei[Qz*/
	char *buf_name;
	char *buf_http_cookie;
	int flag;

	if((http_cookie = getenv("HTTP_COOKIE")) == NULL){
		buf_http_cookie = unknown;
	}else{
		/*CookieH*/
		buf_name = (char *)malloc(strlen(name) + 2);
		sprintf(buf_name, " %s", name);		/*namebuf_nameɑޔA擪ɃXy[X*/
		buf_http_cookie = (char *)malloc(strlen(http_cookie) + 3);
		sprintf(buf_http_cookie, " %s;", http_cookie);		/*http_cookiebuf_http_cookieɑޔA擪ɃXy[X*/

		if(strstr(buf_http_cookie, buf_name) != NULL){
			cookie_value = (char *)malloc(strlen(buf_http_cookie));
			cookie_name = (char *)malloc(strlen(buf_http_cookie));

			for(i = 0; ; i++){
				flag = strspl(cookie_value,buf_http_cookie,';');
				strspl(cookie_name,cookie_value,'=');
				if(!strcmp(cookie_name,buf_name)){
					for(i = 0, count = 0; *(cookie_value + i + 1); i++){
						if(*(cookie_value + i) == '^')
							count++;
					}
					count++;
					tmpval = (char**)malloc(sizeof(char*) * count);
					tmpnam = (char**)malloc(sizeof(char*) * count);
					for(j = 0; j < count; j++){
						tmpval[j] = (char*)malloc(strlen(cookie_value));
						strspl(*(tmpval + j), cookie_value, '^');
						tmpnam[j] = (char*)malloc(strlen(*(tmpval + j)));
						strspl(*(tmpnam + j), *(tmpval + j), '*');
					}
					*cname = tmpnam;
					*cvalue = tmpval;
					break;
				}else{
					if(flag == 0)
						break;
				}
			}
			free(cookie_value);
			free(cookie_name);
			free(buf_http_cookie);
			free(buf_name);
		}
	}
	return count;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid fatal_error (const char *, const char *)
@@@@Fconst char *message		G[bZ[WƂďo͂镶
@@@@@@@const char *body			HTMLBODY
@@@@FmessageŎw肵G[bZ[WBODY̐Fy[W֕\AexitB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void fatal_error(const char* message, const char* body){
	
	puts("Content-Type: text/html\n");
	puts("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">"
		"<HTML><HEAD><TITLE>vIG[</TITLE></HEAD>");
	puts(body);
	puts("<BLOCKQUOTE><BR><BR>");
	puts(message);
	puts("</BLOCKQUOTE></BODY></HTML>");
	
	exit(1);

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint get_int_count (const char *)
@@@@Fconst char *filename	Ώۂ̃t@C
߂l@@@Fint					擾JE^
@@@@Ffilenameint^̐ǂݍݕԂB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int get_int_count(const char* file_path){

	int count;
	char buf[6];
	FILE *fp;
	
	if((fp = fopen(file_path,"r")) == NULL)
		fatal_error("JE^[t@CJ܂","<BODY>");

	fgets(buf,6,fp);
	count = atoi(buf);
	fclose(fp);

	return count;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid put_int_count (const char *, int)
@@@@Fconst char *filename	Ώۂ̃t@C
@@@@@@@int count				int^̐
@@@@FfilenameŎw肳ꂽt@CcountށB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void put_int_count(const char* file_path, int count){

	FILE *fp;
	
	if((fp = fopen(file_path,"w")) == NULL)
		fatal_error("JE^[t@CJ܂","<BODY>");

	fprintf(fp,"%05ld\n",(count+1));
	fclose(fp);

	return;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *check_url (char *)
@@@@Fchar *url		`FbNΏۂURL
߂l@@@Fchar *		`FbN̕
@@@@Furl`ł邩ׁAurlɃXy[X܂܂ꍇ͏B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *check_url(char *url){

	int i;
	int count;
	char *temp;
	
	i = 0;
	count = 0;
	while(url[i] != '\0'){
		if(url[i] == '.')
			count++;
		i++;
	}
	if(i > 8){
		if(count < 1)
			fatal_error(" URĽ``Ⴂ܂BxAm߂B","<body>");
		if(strstr(url, "/") == NULL)
			fatal_error(" URĽ``Ⴂ܂BxAm߂B","<body>");
		if(strstr(url, ",") != NULL)
			fatal_error(" URĽ``Ⴂ܂BxAm߂B","<body>");

		/*URL̋󔒏ׂ̈̏*/

	}
	return url;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid setCfValue(const char *, const char *, const char *)
@@@@Fconst char *cfFname		RtBM[Vt@C
@@@@@@@const char *keyName		lZbgL[̖O
@@@@@@@const char *keyValue		Zbgl
@@@@FcfFnameŎw肳ꂽRtBM[Vt@Cǂݍ݁A
@@@@@@@YkeyName̍sTAlKeyValueɕύXB
@@@@@@@ARtBM[Vt@C͈̏ȉ̒ʂ
@@@@@@@܂A̃t@CɊYL[͈݂Ȃ̂
@@@@@@@B
=============================================================================
KeyName1=KeyValue1
KeyName2=KeyValue2
KeyName3=KeyValue3
=============================================================================
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void setCfValue(const char *cfFname, const char *KeyName, const char *KeyValue){

	char			buf[BUFSIZE];
	char			tmp[BUFSIZE];
	char			tmp2[BUFSIZE];
	char			**bufRead;
	FILE			*rfp, *wfp;
	unsigned int	flag = 0;
	unsigned int	i;
	unsigned int	lines = 0;

	lines = countFileLine(cfFname);
	bufRead = readFile(cfFname, lines);

	if((wfp = fopen(cfFname, "w")) == NULL)
		fatal_error("t@C̃I[vɎs܂B(setCfValue()-2)", "<BODY>");

	for (i = 0; i < lines ; i++){
		strcpy(tmp2, *(bufRead + i));
		strspl(tmp, tmp2, '=');
		if(!strcmp(tmp, KeyName)){
			fprintf(wfp, "%s=%s\n", KeyName, KeyValue);
			flag = 1;
		}else{
			fputs(*(bufRead + i), wfp);
		}
	}

	freeTwoDimArray(bufRead, lines);	/*̈*/

	fclose(wfp);

	if(flag == 0)		/*YL[݂Ȃꍇ͂̃L[쐬*/
		createCfKey(cfFname, KeyName, KeyValue);

	return;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid createCfKey(const char *, const char *, const char *)
@@@@Fconst char *cfFname		RtBM[Vt@C
@@@@@@@const char *keyName		L[̖O
@@@@@@@const char *keyValue		L[ɑ΂l
@@@@FcfFnameŎw肳ꂽRtBM[Vt@C̍ŏIs
@@@@@@@KeyName=KeyValueǉB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void createCfKey(const char *cfFname, const char *KeyName, const char *KeyValue){

	FILE			*afp;

	if((afp = fopen(cfFname, "a")) == NULL)
		fatal_error("t@C̃I[vɎs܂B(setCfValue()-2)", "<BODY>");

	fprintf(afp, "%s=%s\n", KeyName, KeyValue);
	fclose(afp);

	return;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *getFormdataValue(char *, char **, char **, int)
@@@@Fchar *name		l擾name
@@@@@@@char **dname		tH[f[^namei[񎟔z
@@@@@@@char **dvalue		tH[f[^valuei[񎟔z
@@@@@@@int  count		tH[f[^name=valuȇg
Ԃl@@@@char *			nameɑΉvalue
@@@@@@@@@@@@@@@@name݂ȂꍇNULL
@@@@FnameŎw肵valueԂ܂B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *getValue(char *name, char **dname, char **dvalue, int count){

	int	i;

	if(count > 0){
		for(i = 0; i < count; i++){
			if(!strcmp(*(dname + i), name))
				return *(dvalue + i);
		}
	}
	return NULL;

}
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *getValueAlloc(char *, char **, char **, int)
@@@@Fchar *name		l擾name
@@@@@@@char **dname		tH[f[^namei[񎟔z
@@@@@@@char **dvalue		tH[f[^valuei[񎟔z
@@@@@@@int  count		tH[f[^name=valuȇg
Ԃl@@@@char *			nameɑΉvalue
@@@@@@@@@@@@@@@@name݂Ȃꍇ\0ĕԂB
@@@@FnameŎw肵valueԂ܂BgetValueƂ̈Ⴂ͗̈m
@@@@@@@ۂĕԂǂłB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *getValueAlloc(char *name, char **dname, char **dvalue, int count){

	int	i;
	char	*buf;

	buf = (char *)malloc(sizeof(char) * 1);
	*buf = '\0';

	if(count > 0){
		for(i = 0; i < count; i++){
			if(!strcmp(*(dname + i), name)){
				free(buf);
				buf = (char *)malloc(strlen(*(dvalue + i)) + 1);
				strcpy(buf, *(dvalue + i));
			}
		}
	}
	return buf;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint getCfValueInt(FILE *, const char *);
@@@@FFILE *rfp				Yt@Cւ̃|C^
Ԃl@@@@const char *KeyName	oL[̖O
@@@@FrfpŎw肳ꂽt@CKeyNameɊYValueԂB
@@@@@@@Aint^ValueɌ܂B݂Ȃꍇ-1
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int getCfValueInt(FILE *rfp, const char *KeyName){

	unsigned int	i;
	char			*buf;
	char			*tmpKeyName;
	int				KeyValue = -1;

	fseek(rfp, 0L, SEEK_SET); 

	for(i = 0;  ; i++){
		if((buf = fgetLine(rfp)) == NULL)
			break;
		tmpKeyName = (char *)malloc(strlen(buf) + 1);
		removeNewline(buf);
		strspl(tmpKeyName, buf, '=');
		if(!strcmp(KeyName, tmpKeyName)){
			KeyValue = atoi(buf);
			free(tmpKeyName);
			break;
		}
		free(buf);
		free(tmpKeyName);
	}

	return KeyValue;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *getCfValueStr(FILE *, const char *);
@@@@FFILE *rfp				Yt@Cւ̃|C^
Ԃl@@@@const char *KeyName	oL[̖O
@@@@FrfpŎw肳ꂽt@CKeyNameɊYValueԂB
@@@@@@@AValueɌ܂B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *getCfValueStr(FILE *rfp, const char *KeyName){

	unsigned int	i;
	char			*buf;
	char			*tmpKeyName;

	fseek(rfp, 0L, SEEK_SET); 

	for(i = 0;  ; i++){
		if((buf = fgetLine(rfp)) == NULL)
			break;
		tmpKeyName = (char *)malloc(strlen(buf) + 1);
		removeNewline(buf);
		strspl(tmpKeyName, buf, '=');
		if(!strcmp(KeyName, tmpKeyName)){
			free(tmpKeyName);
			return buf;
		}
		free(buf);
		free(tmpKeyName);
	}
	buf = (char *)malloc(sizeof(char) * BUFSIZE);
	*buf = '\0';

	return buf;
}
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *myGetEnv(const char *)
@@@@Fconst char *envName	ϐ
@@@@FenvNameŎw肵ϐ擾Aʂ̗̈ɒlRs[āA
@@@@@@@̗̈ւ̃|C^ԂBϐ̎擾Ɏsꍇ́A
@@@@@@@uUnknownvB܂Å֐̎gp͊Ÿ
@@@@@@@΂āAKfreeEnvironment()Ȃ΂ȂȂB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *myGetEnv(const char *envName){

	char *env;		/*ϐ*/
	char *buf;		/*BUFFER*/

	if((buf = getenv(envName)) == NULL){	/*ϐ̎擾Ɏs*/
		env = (char *)malloc(sizeof(char) * 10);
		strcpy(env, "Unknown");
	}else{
		env = (char *)malloc(strlen(buf) + 1);
		strcpy(env, buf);
	}

	return env;

}
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid freeEnvironment(char *)
@@@@Fϐi[pɊmۂꂽ̈
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void freeEnvironment(char *env){

	if(env)
		free(env);

	return;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid printPageHeader(const char *);
@@@@Fconst char *		y[W̃^Cg
@@@@FCGIwb_HTMLwb_o͂
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void printPageHeader(const char *pageTitle){

	printf("Content-Type: text/html\n\n");
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n"
			"<!--"
			" Programed by Yuto Ikeno.\n"
			" Copyright(C) 1996-98 Myu's Lab. All rights reserved.\n"
			" mailto: mew@onbiz.net\n"
			" http://www.onbiz.net/~mew/\n"
			"-->\n"
			"<HTML>\n"
			"<HEAD>\n"
			"<TITLE>%s</TITLE>\n"
			"<META HTTP-EQUIV=\"Content-Type\"  CONTENT=\"text/html; CHARSET=x-sjis\">\n"
			"</HEAD>\n" ,pageTitle);

	return;

}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFvoid printUrl(char *)
@@@@Fchar *url		o͂URL
@@@@FQƂURL\B
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
void printUrl(char *url){

	int		count;

	for(count = 0 ; ; ){
		if(*(url + count) == '\0')
			break;
		else
			count++;
	}
	if(count > 10)
		printf("\n\n<B> QƁF<A HREF=\"%s\" TARGET=\"_new\">%s</A></B></FONT>",url,url);

	return;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *rmHtmlTag(char *);
@@@@Fchar *str		H镶
@@@@FstrHTML^O
@@@@@@@j<B></B>  
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *rmHtmlTag(char *str){

	unsigned int	flag = 0;
	char			*buf;
	char			*p = str, *p2;

	buf = (char *)malloc(strlen(str) + 1);
	p2 = buf;

	while(*str){
		if(*str == '<'){
			flag = 1;
		}else if(flag == 1){
			if(*str == '>')
				flag = 0;
		}else{
			*buf++ = *str;
		}
		str++;
	}
	*buf = '\0';
	buf = p2;
	str = p;

	return buf;
}

/*End of file*/